Summary: daemontools
Summary(ja): daemontools
Name: daemontools
Version: 0.76
Release: 0vl1
License: BSD License ?
Group: System Environment/Daemons
URL: http://cr.yp.to/daemontools.html
Source0: http://cr.yp.to/daemontools/daemontools-%{version}.tar.gz
Source1: daemontools-%{version}.sysconfig.svscan
Source2: daemontools-%{version}.svscan
Source3: daemontools-%{version}.svscanboot

Patch0: daemontools-%{version}.errno.patch

Buildroot: %{_tmppath}/%{name}-%{version}-root
Requires: glibc >= 2.0.6, initscripts >= 5.60
# Initscripts > 5.60 is required for IPv6 support

#Distribution: Vine Linux
#Vendor: Project Vine
Packager: NOGUCHI Shoji <noguchi@org3.net>

%description
daemontools is a collection of tools for managing UNIX services.

supervise monitors a service. It starts the service and restarts the service if it dies. Setting up a new service is easy: all supervise needs is a directory with a run script that runs the service.

multilog saves error messages to one or more logs. It optionally timestamps each line and, for each log, includes or excludes lines matching specified patterns. It automatically rotates logs to limit the amount of disk space used. If the disk fills up, it pauses and tries again, without losing any data.

%prep
%setup -q -n admin/%{name}-%{version}

%patch0 -p1

pushd src
echo gcc $RPM_OPT_FLAGS > conf-cc
echo gcc -s $RPM_OPT_FLAGS > conf-ld

%__rm -f *.orig *~
popd

#pushd package
#%__sed -e "s!/command!%{_bindir}!" boot.inittab > boot.inittab.tmp \
#&& %__mv boot.inittab.tmp boot.inittab
#popd

%build
cd %{_builddir}/admin/%{name}-%{version}
./package/compile

%install
[ "$RPM_BUILD_ROOT" != "/" ] && %__rm -rf $RPM_BUILD_ROOT

%__mkdir_p $RPM_BUILD_ROOT%{_bindir}
%__mkdir_p $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig
%__mkdir_p $RPM_BUILD_ROOT%{_initrddir}
%__mkdir_p $RPM_BUILD_ROOT%{_var}/service

pushd %{_builddir}/admin/%{name}-%{version}/command
%__install -m 755 svscan $RPM_BUILD_ROOT%{_bindir}/svscan
#%__install -m 755 svscanboot $RPM_BUILD_ROOT%{_bindir}/svscanboot
%__install -m 755 %{SOURCE3} $RPM_BUILD_ROOT%{_bindir}/svscanboot
%__install -m 755 supervise $RPM_BUILD_ROOT%{_bindir}/supervise
%__install -m 755 svc $RPM_BUILD_ROOT%{_bindir}/svc
%__install -m 755 svok $RPM_BUILD_ROOT%{_bindir}/svok
%__install -m 755 svstat $RPM_BUILD_ROOT%{_bindir}/svstat
%__install -m 755 fghack $RPM_BUILD_ROOT%{_bindir}/fghack
%__install -m 755 pgrphack $RPM_BUILD_ROOT%{_bindir}/pgrphack
%__install -m 755 readproctitle $RPM_BUILD_ROOT%{_bindir}/readproctitle
%__install -m 755 multilog $RPM_BUILD_ROOT%{_bindir}/multilog
%__install -m 755 tai64n $RPM_BUILD_ROOT%{_bindir}/tai64n
%__install -m 755 tai64nlocal $RPM_BUILD_ROOT%{_bindir}/tai64nlocal
%__install -m 755 softlimit $RPM_BUILD_ROOT%{_bindir}/softlimit
%__install -m 755 setuidgid $RPM_BUILD_ROOT%{_bindir}/setuidgid
%__install -m 755 envuidgid $RPM_BUILD_ROOT%{_bindir}/envuidgid
%__install -m 755 envdir $RPM_BUILD_ROOT%{_bindir}/envdir
%__install -m 755 setlock $RPM_BUILD_ROOT%{_bindir}/setlock
popd

%__cp -a %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/svscan
%__cp -a %{SOURCE2} $RPM_BUILD_ROOT%{_initrddir}/svscan


%clean
%__rm -rf $RPM_BUILD_ROOT

%post
#if [ -w %{_sysconfdir}/inittab ]; then
#  if %__grep -q "svscanboot" %{_sysconfdir}/inittab > /dev/null; then
#    echo 'inittab contains an svscanboot line. I assume that svscan is already running.'
#  else
#    echo 'Adding svscanboot to inittab...'
#    (%__cat %{_sysconfdir}/inittab \
#     && echo -e "\n#Run svscanboot in standard runlevels\nSV:2345:respawn:%{_bindir}/svscanboot" ) > %{_sysconfdir}/inittab.tmp \
#    && %__mv %{_sysconfdir}/inittab.tmp %{_sysconfdir}/inittab
#    
#    echo '%{_syssbindir}/init q'
#    %{_syssbindir}/init q
#  fi
#fi

/sbin/chkconfig --add svscan

%preun
if [ "$1" = "0" ]: then
  %{_initrddir}/svscan stop > /dev/null 2>&1
  /sbin/chkconfig --del svscan
fi

%postun
#if [ $1 = 0 ]; then
#  if [ -w %{_sysconfdir}/inittab ]; then
#    echo 'Removed svscanboot from inittab.'
#    %__grep -q "svscanboot" %{_sysconfdir}/inittab \
#    && %__grep -v "svscanboot" %{_sysconfdir}/inittab > %{_sysconfdir}/inittab.tmp \
#    && %__mv %{_sysconfdir}/inittab.tmp %{_sysconfdir}/inittab
#    
#    echo '%{_syssbindir}/init q'
#    %{_syssbindir}/init q
#  fi
#fi

%files
%defattr(-,root,root)
%{_bindir}/svscan
%{_bindir}/svscanboot
%{_bindir}/supervise
%{_bindir}/svc
%{_bindir}/svok
%{_bindir}/svstat
%{_bindir}/fghack
%{_bindir}/pgrphack
%{_bindir}/readproctitle
%{_bindir}/multilog
%{_bindir}/tai64n
%{_bindir}/tai64nlocal
%{_bindir}/softlimit
%{_bindir}/setuidgid
%{_bindir}/envuidgid
%{_bindir}/envdir
%{_bindir}/setlock

%config(noreplace) %{_sysconfdir}/sysconfig/svscan
%config %{_initrddir}/svscan

%dir %{_var}/service
